
/************** edit below here  ************/
#include <Python.h>

static PyObject * trial_division(PyObject *self, PyObject *args) {
    unsigned long n, m=7, i=1, dif[8]={6,4,2,4,2,4,6,2};
    if (!PyArg_ParseTuple(args, "k", &n)) return NULL;
    if (n==1)   return PyInt_FromLong(1);
    if (n%2==0) return PyInt_FromLong(2);
    if (n%3==0) return PyInt_FromLong(3);
    if (n%5==0) return PyInt_FromLong(5);
    // Algorithm: only trial divide by numbers that
    // are congruent to 1,7,11,13,17,29,23,29 mod 30=2*3*5.
    while (m*m <= n) {
        if (n%m == 0) return PyInt_FromLong(m);
        m += dif[i%8]; i += 1;
    }
    return PyInt_FromLong(m);
}

static PyMethodDef TrialMethods[] = {
    {"trial_division",  trial_division, METH_VARARGS, "Trial division."},
    {NULL, NULL, 0, NULL}        /* Sentinel */
};

/************** edit above here  ************/
PyMODINIT_FUNC inittrial49278231(void) {
    (void) Py_InitModule("trial49278231", TrialMethods);
}
